#include <iostream.h>
#include <stdio.h>
#include "assign_tokens.h"

extern FILE *yyin;
extern char *yytext;
extern int yylex();

int char_num = 1;
int line_num = 1;
int s_char_num;
int s_line_num;

int main (int argc, char *argv[]) {
  if (argc != 2) {
    cout << "Useage: assign_scan <file>" << endl;
    return -1;
  }

  if ((yyin = fopen(argv[1],"r")) == NULL) {
    cout << "Error!  Unable to open file " << argv[1] << endl;
    return -1;
  }

  int token_num;
  do {
    s_char_num = char_num;
    s_line_num = line_num;
    token_num = yylex();

    cout << "Token: ";
    switch (token_num) {
      case T_EOF: cout << "EOF"; break;
      case T_PLUS: cout << "+"; break;
      case T_TIMES: cout << "*"; break;
      case T_EQUALS: cout << "=="; break;
      case T_ASSIGN: cout << "="; break;
      case T_IDENT: cout << "Ident(" << yytext << ")"; break;
    }
    cout << " found starting at line " << s_line_num << " char " << s_char_num << "\n";
  } while (token_num != T_EOF);

  return 0;
}
